use bevy::math::IVec2;
use bevy_eventwork::NetworkMessage;
use serde::{Deserialize, Serialize};

pub mod server_msg {
	use super::*;

	#[derive(Debug, Serialize, Deserialize)]
	pub struct MapUpdates(pub Vec<(IVec2, (char, char))>);
	netify!(MapUpdates);
}

pub mod client_msg {
	use super::*;

	#[derive(Debug, Serialize, Deserialize)]
	pub struct Move(pub IVec2);
	netify!(Move);
}

macro_rules! netify {
	($name:ident) => {
		impl NetworkMessage for $name {
			const NAME: &'static str = stringify!($name);
		}
	};
}

pub(crate) use netify;

pub const RENDER_DISTANCE: i32 = 12;
